#ifndef CPRI_H
#define CPRI_H

#define CPRI_VERSION_MAJOR      0
#define CPRI_VERSION_MINOR      9
#define CPRI_VERSION_PATCH      5
#define CPRI_VERSION_STRING     "0.9.5"
#define CPRI_DATE               20051029    /* yyyymmdd */
#define CPRI_DATE_STRING "Oct 29, 2005"

#include "cpri/cpricfg.h"

/* Printer commands ====================== */
#define CPRI_MANUAL_FEED  "\033A"
#define  EPC_MANUAL_FEED      'A'

#define CPRI_CASETTE_FEED "\033B"
#define  EPC_CASSETTE_FEED    'B'

#define CPRI_STRIKE       "\033C%s\33"
#define  EPC_STRIKE           'C'

#define CPRI_NEW_LINE     "\033D"
#define  EPC_NEW_LINE         'D'

#define CPRI_NEW_PAGE     "\033E"
#define  EPC_NEW_PAGE         'E'

#define CPRI_BEGIN_TO_BE_REPEATED "\033F"
#define  EPC_BEGIN_TO_BE_REPEATED     'F'

#define CPRI_END_TO_BE_REPEATED   "\033G"
#define  EPC_END_TO_BE_REPEATED       'G'

#define CPRI_TABLE        "\033H%d\33%d\33%d\33"
#define  EPC_TABLE            'H'

#define CPRI_END_TABLE    "\033I"
#define  EPC_END_TABLE        'I'

#define CPRI_LINE_HEIGHT  "\033J%d\33"
#define  EPC_LINE_HEIGHT      'J'

#define CPRI_MERGE_ALL_COLUMNS    "\033K"
#define  EPC_MERGE_ALL_COLUMNS        'K'

#define CPRI_TEXT_TO_VLINE_SPACE  "\033L%d\33"
#define  EPC_TEXT_TO_VLINE_SPACE      'L'
#define CPRI_TEXT_TO_HLINE_SPACE  "\033M%d\33"
#define  EPC_TEXT_TO_HLINE_SPACE      'M'

#define CPRI_PORTRAIT     "\033N"
#define  EPC_PORTRAIT         'N'

#define CPRI_LANDSCAPE    "\033O"
#define  EPC_LANDSCAPE        'O'

#define CPRI_SUP          "\033P%s\33"
#define  EPC_SUP              'P'
#define CPRI_SUP_RALIGN_CELL      "\033Q%s\33"
#define  EPC_SUP_RALIGN_CELL          'Q'
#define CPRI_SUP_RALIGN           "\033R%s\33"
#define  EPC_SUP_RALIGN               'R'
#define CPRI_SUP_LALIGN           "\033S%s\33"
#define  EPC_SUP_LALIGN               'S'

#define CPRI_RESET        "\033T"
#define  EPC_RESET            'T'

#define CPRI_PUSH_POS     "\033U"
#define  EPC_PUSH_POS         'U'
#define CPRI_POP_POS      "\033V"
#define  EPC_POP_POS          'V'

#define CPRI_FONT_SIZE    "\033X%d\33"
#define  EPC_FONT_SIZE        'X'

#define CPRI_FONT_TYPEFACE        "\033Y%d\33%d\33%d\33"
#define  EPC_FONT_TYPEFACE            'Y'
 #define ALBERTUS   0
 #define ANTIQUE    1
 #define TIMES      2
 #define UNIVERS    3
 #define CONDENSED  4
 #define FONT5      5
 #define COURIER    6
 #define GOTHIC     7
 #define SCRIPT     8
 #define FONT10     9
 #define FONT11     10
 #define NOTYPEFACES 11

#define CPRI_UNDERLINE    "\033Z%d\33"
#define  EPC_UNDERLINE        'Z'

#define CPRI_START_RECORD_MACRO   "\033a"
#define  EPC_START_RECORD_MACRO       'a'
#define CPRI_STOP_RECORD_MACRO    "\033b"
#define  EPC_STOP_RECORD_MACRO        'b'

#define CPRI_EXECUTE_MACRO        "\033c"
#define  EPC_EXECUTE_MACRO            'c'

#define CPRI_DELETE_MACROS        "\033d"
#define  EPC_DELETE_MACROS            'd'

#define CPRI_MACROID              "\033e%d\33"
#define  EPC_MACROID                  'e'

#define CPRI_CREATE_COLUMN        "\033f%d\33"
#define  EPC_CREATE_COLUMN            'f'

#define CPRI_MOVE_TO_NEXT_COLUMN  "\033g"
#define  EPC_MOVE_TO_NEXT_COLUMN      'g'

#define CPRI_REMOVE_COLUMNS       "\033h"
#define  EPC_REMOVE_COLUMNS           'h'

#define CPRI_DEACTIVATE_COLUMN    "\033i%d\33"
#define  EPC_DEACTIVATE_COLUMN        'i'

#define CPRI_ACTIVATE_COLUMNS     "\033j"
#define  EPC_ACTIVATE_COLUMNS         'j'

#define CPRI_HORIZONTAL_BAR       "\033k%d\33%d\33%d\33%d\33%d\33"
#define  EPC_HORIZONTAL_BAR           'k'
 #define BAR_PATTERN_BACKW_DIAGONAL_LINES  0
 #define BAR_PATTERN_DIAGONAL_LINES        1
 #define BAR_PATTERN_HLINES                2
 #define BAR_PATTERN_SQUARES               3
 #define BAR_PATTERN_VLINES                4
 #define BAR_PATTERN_DIAGONAL_SQUARES      5
 #define BAR_PATTERN_GRAY                  6
 #define BAR_PATTERN_NR                    7
#define CPRI_END_BAR_LABEL        "\033l"
#define  EPC_END_BAR_LABEL            'l'

#define CPRI_DOSTEXT      "\033m%d\33"
#define  EPC_DOSTEXT          'm'

#define CPRI_HTML_TAG     "\033n%s\33"
#define  EPC_HTML_TAG         'n'

#define CPRI_END_HTML_TAG "\033o"
#define  EPC_END_HTML_TAG     'o'

#define CPRI_CHECK        "\033p"
#define  EPC_CHECK            'p'

#define CPRI_START_GRID   "\033q"
#define  EPC_START_GRID       'q'

#define CPRI_END_GRID     "\033r"
#define  EPC_END_GRID         'r'

#define CPRI_END_START_SEQUENCE   "\033s"
#define  EPC_END_START_SEQUENCE       's'

#define CPRI_ALIGN        "\033t%d\33%s\33"
#define  EPC_ALIGN            't'
 #define ALIGN_LEFT     0
 #define ALIGN_CENTER   1
 #define ALIGN_RIGHT    2
 #define ALIGN_RIGHTHE  3
 #define ALIGN_RIGHTDP  4

#define CPRI_ABS_MOVEX    "\033u%d\33"
#define  EPC_ABS_MOVEX        'u'
#define CPRI_ABS_MOVEY    "\033v%d\33"
#define  EPC_ABS_MOVEY        'v'
#define CPRI_REL_MOVEX    "\033x%d\33"
#define  EPC_REL_MOVEX        'x'
#define CPRI_REL_MOVEY    "\033y%d\33"
#define  EPC_REL_MOVEY        'y'

#define CPRI_RECTANGLE    "\033z%d\33%d\33"
#define  EPC_RECTANGLE        'z'

#define CPRI_NR_OF_COPIES "\0330%d\33"
#define  EPC_NR_OF_COPIES     '0'

#define CPRI_BAR_CODE     "\0331%s\33"
#define  EPC_BAR_CODE         '1'

#define CPRI_BAR_CODE_W   "\0332%d\33"
#define  EPC_BAR_CODE_W       '2'

#define CPRI_BAR_CODE_H   "\0333%d\33"
#define  EPC_BAR_CODE_H       '3'

#define CPRI_SCALING      "\0334%d\33"
#define  EPC_SCALING          '4'

#define CPRI_FIX_ROW_HEIGHT       "\0335%d\33"
#define  EPC_FIX_ROW_HEIGHT           '5'

/* Printer functions ====================== */

struct t_handle;
typedef struct t_handle* t_handle;
typedef const char* t_command;

CPRI_FUNC(int, CpriCommand, (t_handle hnd, t_command cmd, ...));
CPRI_FUNC(int, CpriText, (t_handle hnd, const char *string));
CPRI_FUNC(t_handle, CpriOpenEntry, (int q, const char *p_name, int, const char *fn));
CPRI_FUNC(int, CpriCloseEntry, (t_handle hnd));
CPRI_FUNC(void, CpriPrinterPortDialogue, (void));
CPRI_FUNC(void, CpriPrinterQueueMonitor, (void));
CPRI_FUNC(void, CpriInitPrinter, (void));
CPRI_FUNC(void, CpriDeInitPrinter, (void));
CPRI_FUNC(void, CpriPrintingProperties, (int port, int use, int brand, const char *cmd1, const char *cmd2));
CPRI_FUNC(int, CpriIsSpooling, (void));
CPRI_FUNC(const char *const*, CpriGetQueueNames, (void));
CPRI_FUNC(const char *const*, CpriGetDriverNames, (void));
CPRI_FUNC(const char *const*, CpriGetTypefaceNames, (void));
CPRI_FUNC(const char *const*, CpriGetBarIcons, (void));

#define QUEUE_LPT1      0
#define QUEUE_LPT2      1
#define QUEUE_LPT3      2
#define QUEUE_DOSPRINT  3
#define QUEUE_NETPORT   4
#define QUEUE_OPTIMALPORT 5
#define QUEUE_REQUEST   6
#define NR_OF_QUEUES    7

#define BRAND_HP        0
#define BRAND_NEC       1
#define BRAND_KYOCERA   2
#define BRAND_BROTHER   3
#define BRAND_UNKNOWN   4
#define NODRIVERS       5

#endif
