#ifndef DRV_COMMON_H
#define DRV_COMMON_H

typedef struct t_tab {
   int mm;
   int block;
   int scaled;
   int inactive;
} t_tab;

typedef struct t_tab_frame {
   t_tab *tabs;
   int n;
   int maxtabs;
   int curtab;
   int prevtab;
} t_tab_frame;

extern void _CpriSetTab(t_tab_frame *tf, int w, float scaling);
extern void _CpriInitTabs(t_tab_frame *tf, int leftx, float scaling);
extern void _CpriSetSoftMargin(t_tab_frame *tf, t_tab *margin, int newmargin,
                          float scaling);
extern void _CpriMoveToNextCell(t_tab_frame *tf);
extern void _CpriRemovePriTab(t_tab_frame *tf, unsigned tabno);
extern void _CpriMergeAllColumns(t_tab_frame *tf);
extern void _CpriActivateTabs(t_tab_frame *tf);
extern char _CpriToDOS(char c, int symbolset);
extern void _CpriCopyTabFrame(t_tab_frame *from, t_tab_frame *to);
extern void _CpriDestroyTabFrame(t_tab_frame *f);

/* Acronyms for the half-character. */
#define HALF_CHAR '\xbd'
#define HALF_STRING "\xbd"
#define MINUS_HALF_STRING "-\xbd"

#endif
