/* Module WIDTH
   Contains the function for determining the width of a string for a certain
   printer brand */

#ifndef _WIN32
#include "spooler.h"
#include "drv_common.h"
#include "width.h"
#include "font_w.inc"
#include "org_nec.inc"

extern int string_width(const unsigned char *s, int font, int stroke, int style,
                        int size, int xtended, int scaling)
{
   /* returns textlength in dots */
   int x = 0, i = 0;            /* defult is Universe */

   switch (font) {
   case ALBERTUS:
      i = 13;
      if (stroke)
         i++;
      break;
   case ANTIQUE:
      i = 10;
      if (stroke)
         i++;
      else if (style)
         i += 2;
      break;
   case TIMES:
      i = 0;
      if (stroke)
         i++;
      if (style)
         i += 2;
      break;
   case UNIVERS:
      i = 4;
      break;
   case CONDENSED:
      i = 5;
      if (stroke)
         i++;
      break;
   case FONT5:
      i = 15;
      if (stroke)
         i++;
      if (style)
         i += 2;
      break;
   case COURIER:
   case GOTHIC:
      for (; *s; s++)
         x += 254;
      return x/10;
   case SCRIPT:
      i = 8;
      break;
   case FONT10:
      i = 7;
      break;
   case FONT11:
      i = 9;
      break;
   }
   if (xtended) {
      for (; *s; s++)
         x += fontsizes[i][*s - 32];
   } else {
      for (; *s; s++)
         x += minor_fontsizes[i][*s - 32];
   }
   return x * size * scaling / (12 * 2540);
}
#endif
